/**
 * 
 */
package org.ajax4jsf.builder.maven;

import java.io.File;
import java.io.FileWriter;

import org.apache.velocity.Template;
import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;
import org.codehaus.plexus.velocity.VelocityComponent;

/**
 * @author Maksim Kaszynski
 *
 */
public class VelocityTaglibMergeCallBack implements XMLMergeCallback {

	private File target;
	
	private String template;
	
	private VelocityComponent velocity;
	
	private VelocityContext initialContext;
	
	/* (non-Javadoc)
	 * @see org.ajax4jsf.builder.maven.XMLMergeCallback#onMergeComplete(java.lang.String)
	 */
	public void onMergeComplete(String mergedContent) throws Exception{
		
		VelocityContext velocityContext;
		
		if (initialContext != null) {
			velocityContext = new VelocityContext(initialContext);
		} else {
			velocityContext = new VelocityContext();
		}
		
		VelocityEngine velocityEngine = velocity.getEngine();
		Template template2 = velocityEngine.getTemplate(template);
		
		File parentFile = target.getParentFile();
		if (!parentFile.exists()) {
			parentFile.mkdirs();
		}
		
		FileWriter fileWriter = new FileWriter(target);
		
		template2.merge(velocityContext, fileWriter);
		fileWriter.flush();
		fileWriter.close();
	}

}
